const amf = require('amf-client-js');
const fs = require('fs');

amf.plugins.document.WebApi.register();
amf.plugins.document.Vocabularies.register();
amf.plugins.features.AMFValidation.register();

const dataPath = 'demo/demo-api/demo-api.raml';
amf.Core.init().then(() => {
  const ramlParser = amf.Core.parser('RAML 1.0', 'application/yaml');
  const jsonLdParser = amf.Core.generator('AMF Graph', 'application/ld+json');
  ramlParser.parseFileAsync(`file://${dataPath}`)
  .then((doc) => {
    const r = amf.Core.resolver('RAML 1.0');
    doc = r.resolve(doc, 'editing');
    return jsonLdParser.generateString(doc);
  })
  .then((data) => fs.writeFile(`./demo/amf-model.json`, data, 'utf8'))
  .then(() => console.log('Data saved'))
  .catch((cause) => {
    console.error(cause);
  });
});
